jjb: Add workaround for newer pahole versions with focal kernels
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
1 #!/bin/bash
2 #
3 # Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
17
18 set -exu
19
20 # Parameters
21 platforms=${platforms:-}
22 # Derive arch from label if it isn't set
23 if [ -z "${arch:-}" ] ; then
24 # Labels may be platform specific, eg. jammy-amd64, deb12-armhf
25 regex='[[:alnum:]]+-([[:alnum:]]+)'
26 if [[ "${platforms}" =~ ${regex} ]] ; then
27 arch="${BASH_REMATCH[1]}"
28 else
29 arch="${platforms:-}"
30 fi
31 fi
32
33 cross_arch=${cross_arch:-}
34 ktag=${ktag:-}
35 kgitrepo=${kgitrepo:-}
36 mversion=${mversion:-}
37 mgitrepo=${mgitrepo:-}
38 make_args=()
39
40 DEBUG=${DEBUG:-}
41
42 ## FUNCTIONS ##
43
44 # Kernel version compare functions
45 verlte() {
46 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
47 }
48
49 verlt() {
50 # shellcheck disable=SC2015
51 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
52 }
53
54 vergte() {
55 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
56 }
57
58 vergt() {
59 # shellcheck disable=SC2015
60 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
61 }
62
63 git_clone_modules_sources() {
64 mkdir -p "$MODULES_GIT_DIR"
65
66 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
67 # as a branch name.
68 if [ "${mversion:0:5}" = "refs/" ]; then
69 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
70 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
71 else
72 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
73 fi
74 }
75
76 # Checkout a shallow kernel tree of the specified tag
77 git_clone_linux_sources() {
78 mkdir -p "$LINUX_GIT_DIR"
79 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
80 }
81
82
83 # Export the kernel sources from the git repo
84 git_export_linux_sources() {
85 cd "$LINUX_GIT_DIR"
86 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
87 }
88
89
90 # Upload the tar archive to the object store
91 upload_archive_obj() {
92 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
93 rm -f "$WORKSPACE/$obj_name"
94 }
95
96
97 extract_archive_obj() {
98 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR" -I pbzip2
99 rm -f "$WORKSPACE/$obj_name"
100 }
101
102
103 tar_archive_obj() {
104 cd "$LINUX_OBJ_DIR"
105 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
106 cd -
107 }
108
109 list_gccs() {
110 local gccs
111 gccs=()
112 IFS=: read -r -a path_array <<< "$PATH"
113 while read -r gcc ; do
114 gccs+=("$gcc")
115 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
116 echo "${gccs[@]}"
117 }
118
119 # Find the most recent GCC version supported by the kernel sources
120 select_compiler() {
121 local selected_cc
122
123 cd "$LINUX_SRCOBJ_DIR"
124
125 kversion=$(make -s kernelversion)
126
127 set +e
128
129 for cc in $(list_gccs) ; do
130 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
131 cc_version=$(echo "${cc}" | cut -d'-' -f2)
132 if { verlt "${kversion}" "5.17"; } && { vergt "${cc_version}" "11"; } ; then
133 # Using gcc-12+ with '-Wuse-after-free' breaks the build of older
134 # kernels (in particular, objtool). Some releases on LTS
135 # branches between 4.x and 5.15 can be built with gcc-12.
136 # @see https://lore.kernel.org/lkml/20494.1643237814@turing-police/
137 # @see https://gitlab.com/linux-kernel/stable/-/commit/52a9dab6d892763b2a8334a568bd4e2c1a6fde66
138 continue
139 fi
140 selected_cc="$cc"
141 break
142 fi
143 done
144
145 set -e
146
147 # Force gcc-4.8 for kernels before 4.4
148 if { verlt "$kversion" "4.4"; }; then
149 selected_cc='gcc-4.8'
150 fi
151
152 if [ "x$selected_cc" = "x" ]; then
153 echo "Found no suitable compiler."
154 exit 1
155 fi
156
157 _KAFLAGS=()
158 _KCFLAGS=()
159 _KCPPFLAGS=()
160 _HOSTCFLAGS=()
161 if [ "$selected_cc" != "gcc-4.8" ]; then
162 # Older kernel Makefiles do not expect the compiler to default to PIE
163 _KAFLAGS+=(-fno-pie)
164 _KCFLAGS+=(
165 -fno-pie
166 -no-pie
167 -fno-stack-protector
168 )
169 _KCPPFLAGS+=(-fno-pie)
170 fi
171
172 selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
173 if { vergte "${selected_cc_version}" "10"; } && { verlt "${kversion}" "5.10"; } ; then
174 # gcc-10 changed the default from '-fcommon' to '-fno-common', which
175 # causes a linker failure. '-fcommon' can be set on the HOSTCFLAGS
176 # to avoid the issue.
177 # @see https://gitlab.com/linux-kernel/stable/-/commit/e33a814e772cdc36436c8c188d8c42d019fda639
178 _HOSTCFLAGS+=(-fcommon)
179 fi
180
181 if [ "${cross_arch:-}" == "armhf" ] ; then
182 if { verlt "${kversion}" "5.14"; } ; then
183 # Work-around for producing instructions that aren't valid for the
184 # default architectures.
185 # Eg. Error: selected processor does not support `cpsid i' in ARM mode
186 _KCFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
187 _KCPPFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
188 fi
189 fi
190
191 if { vergt "${selected_cc_version}" "8"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
192 # This was added to -Wall in gcc 9 but some kernels do not include the fixes
193 # @see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88583
194 _KCFLAGS+=(-Wno-error=packed-not-aligned)
195 fi
196
197 export KAFLAGS="${_KAFLAGS[*]}"
198 export KCFLAGS="${_KCFLAGS[*]}"
199 export KCPPFLAGS="${_KCPPFLAGS[*]}"
200 export HOSTCFLAGS="${_HOSTCFLAGS[*]}"
201 export CC="${CROSS_COMPILE:-}${selected_cc}"
202 export HOSTCC="${selected_cc}"
203
204 make_args=(
205 CC="${CC}"
206 HOSTCC="${HOSTCC}"
207 HOSTCFLAGS="${HOSTCFLAGS:-}"
208 )
209 if [ -n "${DEBUG}" ] ; then
210 make_args+=(
211 V=1
212 )
213 fi
214 cd -
215 }
216
217 patch_linux_kernel() {
218 local commit_hash
219 commit_hash="$1"
220 set +e
221 git -C "${LINUX_GIT_REF_REPO_DIR}" format-patch -n1 --stdout "${commit_hash}" | patch -p1
222 set -e
223 if [ "$?" -gt 1 ] ; then
224 echo "Serious issue patching"
225 exit 1
226 fi
227 }
228
229 build_linux_kernel() {
230 cd "$LINUX_SRCOBJ_DIR"
231
232 kversion=$(make -s kernelversion "${make_args[@]}")
233 pahole_version="$(pahole --version | tr -d 'v')"
234
235 if { verlt "${kversion}" "3.3"; } && [ "${vanilla_config}" = "imx_v6_v7_defconfig" ] ; then
236 # imx_v6_v7 didn't exist before 06965c39b4c63933fa0a1cde2237ef85477c5655
237 if { verlt "${kversion}" "3.2"; } ; then
238 vanilla_config='mx5_defconfig'
239 else
240 vanilla_config='mx51_defconfig'
241 fi
242 fi
243
244 if { verlt "${kversion}" "3.13"; } && [ "${vanilla_config}" = "pseries_le_defconfig" ] ; then
245 # pseries_le_deconfig was introduced in f53e462e907cbaed29c49c0f10f5b8f614e1bf1d
246 vanilla_config='pseries_defconfig'
247 fi
248
249 # Generate kernel configuration
250 case "$ktag" in
251 Ubuntu*)
252 if [ "${cross_arch}" = "powerpc" ]; then
253 if vergte "${kversion}" "4.10"; then
254 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
255 exit 0
256 fi
257 fi
258
259 # Disable riscv64 config generation, we don't have a toolchain on bionic
260 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
261
262 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
263
264 # Hack for kernel Ubuntu-hwe-5.8
265 # The debian/control file is produced by the clean target above, so this
266 # check needs to happen afterwards.
267 if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
268 echo "10" > "debian/compat"
269 fi
270
271 # genconfigs check can fail in certain cases, eg. when a more recent
272 # compiler exposes kernel configuration flags which aren't set in the
273 # Ubuntu annotations.
274 # In any case, the configuration will be updated with any missing values
275 # later in our build script.
276 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
277 cp CONFIGS/"${ubuntu_config}" .config
278 ;;
279
280 *)
281 # Force 32bit build on i386, default is 64bit
282 if [ "$arch" = "i386" ]; then
283 export ARCH="i386"
284 fi
285
286 make "${vanilla_config}" "${make_args[@]}"
287 ;;
288 esac
289
290 if [ "${vanilla_config}" = "pseries_defconfig" ] && [ "${cross_arch}" = "ppc64el" ] ; then
291 # @see diff <(git show v3.13:arch/powerpc/configs/pseries_defconfig) <(git show v3.13:arch/powerpc/configs/pseries_le_defconfig)
292 scripts/config --enable CONFIG_CPU_LITTLE_ENDIAN
293 scripts/config --enable CONFIG_CMA
294 scripts/config --disable CONFIG_XMON_DEFAULT
295 # scripts/config --disable CONFIG_VIRTUALIZATION
296 # scripts/config --disable CONFIG_KVM_BOOK3S_64
297 scripts/config --disable CONFIG_KVM_BOOK3S_64_HV
298 fi
299
300 # oldnoconfig was renamed in 4.19
301 if vergte "$kversion" "4.19"; then
302 update_conf_target="olddefconfig"
303 else
304 update_conf_target="oldnoconfig"
305 fi
306
307 # Fix 'defined(@array)' was removed from recent perl
308 if [ -f "kernel/timeconst.pl" ]; then
309 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
310 fi
311
312 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
313 if [ "$HOSTCC" != "gcc-4.8" ]; then
314 if [ -f "arch/x86/kvm/svm.c" ]; then
315 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
316 fi
317
318 if [ -f "arch/x86/kvm/vmx.c" ]; then
319 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
320 fi
321 fi
322
323 if { verlt "${kversion}" "5.11"; } && { vergte "${kversion}" "4.10"; } ; then
324 # Binutils > 2.35 strips empty symbol tables, causing obltool to fail
325 # in certain cases when files are empty.
326 # @see https://gitlab.com/linux-kernel/stable/-/commit/1d489151e9f9d1647110277ff77282fe4d96d09b
327 #
328 # There doesn't seem to be any LD/AS/AR flags to control this behaviour,
329 # therefore patching tools/objtool/elf.c is attempted.
330 patch_linux_kernel 1d489151e9f9d1647110277ff77282fe4d96d09b
331 if { verlt "${kversion}" "4.18"; } ; then
332 patch_linux_kernel e81e0724432542af8d8c702c31e9d82f57b1ff31
333 fi
334 fi
335
336 if { vergt "${selected_cc_version}" "7"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
337 # Builds fail due to -Werror=restrict in pager.o and str_error_r.o
338 if { verlt "${kversion}" "4.16"; } ; then
339 # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
340 # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=ad343a98e74e85aa91d844310e797f96fee6983b
341 patch_linux_kernel ad343a98e74e85aa91d844310e797f96fee6983b
342 fi
343 if { verlt "${kversion}" "4.17"; } ; then
344 # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
345 # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=854e55ad289ef8888e7991f0ada85d5846f5afb9
346 patch_linux_kernel 854e55ad289ef8888e7991f0ada85d5846f5afb9
347 fi
348
349 # More recent compiler optimizations expose build errors with netronome.
350 # It seems easier to disable the driver than to attempt patching.
351 scripts/config --disable CONFIG_NET_VENDOR_NETRONOME
352 scripts/config --disable CONFIG_MICREL_PHY
353
354 # Duplicate decalarations of __force_order
355 # @see https://gitlab.com/linux-kernel/stable/-/commit/df6d4f9db79c1a5d6f48b59db35ccd1e9ff9adfc
356 # However, kaslr_64.c doesn't exit in 4.15, 4.16, it's named pagetable.c
357 if [ -f arch/x86/boot/compressed/pagetable.c ] ; then
358 sed -i '/^unsigned long __force_order;$/d' arch/x86/boot/compressed/pagetable.c
359 fi
360 fi
361
362 if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.18"; } ; then
363 # Some old kernels fail to build when make is too new
364 # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
365 patch_linux_kernel 9564a8cf422d7b58f6e857e3546d346fa970191e
366 # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
367 patch_linux_kernel 9feeb638cde083c737e295c0547f1b4f28e99583
368 fi
369
370 if { vergte "${kversion}" "4.12"; } && { verlt "${kversion}" "4.18"; } ; then
371 # Old kernels can fail to build while on newer host kernels
372 # @see https://gitlab.com/linux-kernel/stable/-/commit/dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
373 #
374 patch_linux_kernel dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
375 fi
376
377 if { vergte "${kversion}" "3.18"; } && { verlt "${kversion}" "4.4"; } ; then
378 # Compatibility with binutils >= ~ 2.31
379 patch_linux_kernel b21ebf2fb4cde1618915a97cc773e287ff49173e
380 fi
381
382 # The above patch only partially applies linux 3.17, and has been, so a
383 # rebased version is used instead.
384 if { vergte "${kversion}" "3.17"; } && { verlt "${kversion}" "3.18"; } ; then
385 cat <<'EOF' | patch -p1
386 diff --git a/arch/x86/kernel/machine_kexec_64.c b/arch/x86/kernel/machine_kexec_64.c
387 index 48598105..0652c5b6 100644
388 --- a/arch/x86/kernel/machine_kexec_64.c
389 +++ b/arch/x86/kernel/machine_kexec_64.c
390 @@ -516,6 +516,7 @@ int arch_kexec_apply_relocations_add(const Elf64_Ehdr *ehdr,
391 goto overflow;
392 break;
393 case R_X86_64_PC32:
394 + case R_X86_64_PLT32:
395 value -= (u64)address;
396 *(u32 *)location = value;
397 break;
398 diff --git a/arch/x86/kernel/module.c b/arch/x86/kernel/module.c
399 index e69f9882..7c6bc9fe 100644
400 --- a/arch/x86/kernel/module.c
401 +++ b/arch/x86/kernel/module.c
402 @@ -180,6 +180,7 @@ int apply_relocate_add(Elf64_Shdr *sechdrs,
403 goto overflow;
404 break;
405 case R_X86_64_PC32:
406 + case R_X86_64_PLT32:
407 val -= (u64)loc;
408 *(u32 *)loc = val;
409 #if 0
410 diff --git a/arch/x86/tools/relocs.c b/arch/x86/tools/relocs.c
411 index bbb1d225..8deeacbc 100644
412 --- a/arch/x86/tools/relocs.c
413 +++ b/arch/x86/tools/relocs.c
414 @@ -763,6 +763,7 @@ static int do_reloc64(struct section *sec, Elf_Rel *rel, ElfW(Sym) *sym,
415 switch (r_type) {
416 case R_X86_64_NONE:
417 case R_X86_64_PC32:
418 + case R_X86_64_PLT32:
419 /*
420 * NONE can be ignored and PC relative relocations don't
421 * need to be adjusted.
422 EOF
423 fi
424
425 if ( { vergte "${kversion}" "3.15"; } && { verlt "${kversion}" "4.4"; } ) ||
426 ( { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ); then
427 # While the original motivation of this patch is for fixing builds using
428 # clang, the same error occurs between linux >= 3.15 and < 4.4, and in
429 # 4.15, 4.16.
430 #
431 # This patch only partially applies due to changes in kernel/Makefile,
432 # so a supplementary patch is needed
433 #
434 # Without this patch, builds fail with
435 # Cannot find symbol for section 2: .text.
436 # kernel/elfcore.o: failed
437 #
438 # @see https://github.com/linuxppc/issues/issues/388
439 # @see https://lore.kernel.org/lkml/20201204165742.3815221-2-arnd@kernel.org/
440 #
441 patch_linux_kernel 6e7b64b9dd6d96537d816ea07ec26b7dedd397b9
442 if grep -q elfcore.o kernel/Makefile ; then
443 sed -i '/^.* += elfcore.o$/d' kernel/Makefile
444 fi
445 fi
446
447 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
448 # Convert them to 'cmpw' which was previously done silently
449 if verlt "$kversion" "4.9"; then
450 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
451 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
452 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
453 fi
454
455 # Fix a typo in v2.6.36.x
456 if [ -f "arch/x86/kernel/entry_64.S" ]; then
457 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
458 fi
459
460 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
461 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
462 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
463 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
464 fi
465
466 # Fix kernel < 3.0 with gcc >= 4.7
467 if verlt "$kversion" "3.0"; then
468 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
469 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
470 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
471 echo "header-y += linkage.h" >> include/linux/Kbuild
472 fi
473
474 if [ "${cross_arch}" = "powerpc" ] ; then
475 if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.16"; } ; then
476 # Avoid register errors such as
477 # aes_generic.c:(.text+0x4e0): undefined reference to `_restgpr_31_x'
478 # @see https://gitlab.com/linux-kernel/stable/-/commit/148b974deea927f5dbb6c468af2707b488bfa2de
479 make_args+=(
480 CFLAGS_aes_generic.o=''
481 )
482 fi
483 fi
484
485 if [ "$(scripts/config --state CONFIG_DEBUG_INFO_BTF)" == "y" ] &&
486 { vergte "${pahole_version}" "1.24"; } &&
487 { vergte "${kversion}" "5.10"; } && { verlt "${kversion}" "6.0"; } ;then
488 # Some kernels Eg. Ubuntu-hwe-5.13-5.13.0-52.59_20.04.1
489 # fail with the following error:
490 # BTFIDS vmlinux
491 # FAILED: load BTF from vmlinux: Invalid argument
492 #
493 # When CONFIG_DEBUG_INFO_BTF is set, certain versions of pahole require
494 # `--skip_encoding_btf_enum64` to be passed as the kernel doesn't define
495 # BTF_KIND_ENUM64.
496 #
497 # Introduced in 341dfcf8d78eaa3a2dc96dea06f0392eb2978364 (~v5.10)
498 # @see https://lore.kernel.org/bpf/20220825171620.cioobudss6ovyrkc@altlinux.org/t/
499 #
500 if [ -f "scripts/pahole-flags.sh" ] ; then
501 sed -i 's/ -J ${PAHOLE_FLAGS} / -J ${PAHOLE_FLAGS} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
502 else
503 sed -i 's/ -J ${extra_paholeopt} / -J ${extra_paholeopt} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
504 fi
505 fi
506
507 # GCC 4.8
508 if [ "$HOSTCC" == "gcc-4.8" ]; then
509 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
510 scripts/config --disable CONFIG_PPC_OF_BOOT_TRAMPOLINE
511 fi
512
513 # Don't try to sign modules
514 scripts/config --disable CONFIG_MODULE_SIG
515
516 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
517 scripts/config --disable CONFIG_STACK_VALIDATION
518
519 # Cause problems with inline assembly on i386
520 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
521
522 # Don't build samples, they are broken on some kernel releases
523 scripts/config --disable CONFIG_SAMPLES
524 scripts/config --disable CONFIG_BUILD_DOCSRC
525
526 # Disable kcov
527 scripts/config --disable CONFIG_KCOV
528
529 # Broken on some RT kernels
530 scripts/config --disable CONFIG_HYPERV
531
532 # Broken drivers
533 scripts/config --disable CONFIG_RAPIDIO_TSI721
534 scripts/config --disable CONFIG_SGI_XP
535 scripts/config --disable CONFIG_MFD_WM8994
536 scripts/config --disable CONFIG_DRM_RADEON
537 scripts/config --disable CONFIG_SND_SOC_WM5100
538
539 # IGBVF won't build with recent gcc on 2.6.38.x
540 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
541 scripts/config --disable CONFIG_IGBVF
542 fi
543
544 # Don't fail the build on warnings
545 scripts/config --disable CONFIG_WERROR
546 scripts/config --enable CONFIG_PPC_DISABLE_WERROR
547
548 # Set required options
549 scripts/config --enable CONFIG_TRACEPOINTS
550 scripts/config --enable CONFIG_KALLSYMS
551 scripts/config --enable CONFIG_HIGH_RES_TIMERS
552 scripts/config --enable CONFIG_KPROBES
553 scripts/config --enable CONFIG_FTRACE
554 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
555 scripts/config --enable CONFIG_KALLSYMS_ALL
556 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
557 scripts/config --enable CONFIG_PERF_EVENTS
558 scripts/config --enable CONFIG_EVENT_TRACING
559 scripts/config --enable CONFIG_KRETPROBES
560
561 if [ -n "${DEBUG}" ] ; then
562 cat .config
563 fi
564
565 make "$update_conf_target" "${make_args[@]}"
566 make -j"$NPROC" "${make_args[@]}"
567
568 krelease=$(make -s kernelrelease "${make_args[@]}")
569
570 # Save the kernel and modules
571 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
572 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install "${make_args[@]}"
573 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install "${make_args[@]}"
574 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
575 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
576 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
577 }
578
579
580 extract_distro_headers() {
581
582 # Enter linux source dir
583 cd "${LINUX_SRCOBJ_DIR}"
584
585
586 # For RT kernels, copy version file
587 if [ -s localversion-rt ]; then
588 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
589 fi
590
591 # Copy all Makefile related stuff
592 find . -path './include/*' -prune \
593 -o -path './scripts/*' -prune -o -type f \
594 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
595 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
596 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
597
598 # Copy base scripts and include dirs
599 cp -a scripts include "${LINUX_HDROBJ_DIR}"
600
601 # Copy arch includes
602 (find arch -name include -type d -print0 | \
603 xargs -0 -n1 -i: find : -type f) | \
604 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
605
606 # Copy arch scripts
607 (find arch -name scripts -type d -print0 | \
608 xargs -0 -n1 -i: find : -type f) | \
609 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
610
611 # Cleanup scripts
612 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
613 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
614
615 # On powerpc 32bits this object is required to link modules
616 if [ "${karch}" = "powerpc" ]; then
617 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
618 :
619 else
620 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
621 fi
622 fi
623
624 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
625 if [ "${karch}" = "arm64" ]; then
626 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
627 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
628 fi
629 fi
630
631 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
632 if [ -f tools/objtool/objtool ]; then
633 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
634 fi
635
636 if [ -f "arch/x86/kernel/macros.s" ]; then
637 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
638 fi
639
640 # Copy modules related stuff, if available
641 if [ -s Module.symvers ]; then
642 cp Module.symvers "${LINUX_HDROBJ_DIR}"
643 fi
644
645 if [ -s System.map ]; then
646 cp System.map "${LINUX_HDROBJ_DIR}"
647 fi
648
649 if [ -s Module.markers ]; then
650 cp Module.markers "${LINUX_HDROBJ_DIR}"
651 fi
652
653 # Copy config file
654 cp .config "${LINUX_HDROBJ_DIR}"
655
656 # Make sure the Makefile and version.h have a matching timestamp so that
657 # external modules can be built
658 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
659 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
660 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
661 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
662 else
663 echo "Missing version.h"
664 exit 1
665 fi
666 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
667
668 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
669 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
670 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
671 fi
672
673 # Finally clean the object files from the full source tree
674 make clean
675
676 # And regen the modules support files
677 make modules_prepare "${make_args[@]}"
678
679 # On powerpc 32bits this object is required to link modules
680 if [ "${karch}" = "powerpc" ]; then
681 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
682 :
683 else
684 make arch/powerpc/lib/crtsavres.o "${make_args[@]}"
685 fi
686 fi
687
688 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
689 if [ "${karch}" = "arm64" ]; then
690 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
691 make arch/arm64/kernel/ftrace-mod.o "${make_args[@]}"
692 fi
693 fi
694
695 # Version specific tasks
696 case "$ktag" in
697 Ubuntu*)
698 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
699 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
700 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
701 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
702 ;;
703 esac
704 }
705
706
707 build_modules() {
708
709 local kdir="$1"
710 local outdir="$2"
711 local kversion
712
713 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
714
715 # Try to catch some compatibility problems by turning some
716 # warnings into errors.
717 #export KCFLAGS="$KCFLAGS -Wall -Werror"
718
719 # Enter lttng-modules source dir
720 cd "${MODULES_GIT_DIR}"
721
722 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
723 # timekeeping subsystem. We want those build to fail.
724 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
725 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
726
727 set +e
728
729 # Build modules
730 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
731 ret=$?
732
733 set -e
734
735 # We expect this build to fail, if it doesn't, fail the job.
736 if [ "$ret" -eq 0 ]; then
737 echo "This build should have failed."
738 exit 1
739 fi
740
741 # We have to publish at least one file or the build will fail
742 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
743
744 KERNELDIR="${kdir}" make clean
745
746 else # Regular build
747
748 # Build modules against full kernel sources
749 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
750
751 # Install modules to build dir
752 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
753
754 # Clean build dir
755 KERNELDIR="${kdir}" make clean
756 fi
757 }
758
759
760 ## MAIN ##
761
762 # Use all CPU cores
763 NPROC=$(nproc)
764
765 MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
766 LINUX_GIT_DIR="${WORKSPACE}/src/linux"
767
768 LINUX_OBJ_DIR="${WORKSPACE}/linux"
769 LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
770 LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
771 LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
772
773 MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
774 MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
775
776 LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
777
778 OBJ_STORE_URL="s3://jenkins"
779
780 cd "$WORKSPACE"
781
782 # Create build directories
783 mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
784
785 git_clone_modules_sources
786
787 # Setup cross compile env if available
788 if [ "x${cross_arch}" != "x" ]; then
789
790 case "$cross_arch" in
791 "armhf")
792 karch="arm"
793 cross_compile="arm-linux-gnueabihf-"
794 vanilla_config="imx_v6_v7_defconfig"
795 ubuntu_config="armhf-config.flavour.generic"
796 ;;
797
798 "arm64")
799 karch="arm64"
800 cross_compile="aarch64-linux-gnu-"
801 vanilla_config="defconfig"
802 ubuntu_config="arm64-config.flavour.generic"
803 ;;
804
805 "powerpc")
806 karch="powerpc"
807 cross_compile="powerpc-linux-gnu-"
808 vanilla_config="ppc44x_defconfig"
809 ubuntu_config="powerpc-config.flavour.powerpc-smp"
810 ;;
811
812 "ppc64el")
813 karch="powerpc"
814 cross_compile="powerpc64le-linux-gnu-"
815 vanilla_config="pseries_le_defconfig"
816 ubuntu_config="ppc64el-config.flavour.generic"
817 ;;
818
819 *)
820 echo "Unsupported cross arch $cross_arch"
821 exit 1
822 ;;
823 esac
824
825 # Export variables used by Kbuild for cross compilation
826 export ARCH="${karch}"
827 export CROSS_COMPILE="${cross_compile}"
828
829 # Set arch specific values if we are not cross compiling
830 elif [ "x${arch}" != "x" ]; then
831
832 case "$arch" in
833 "i386")
834 karch="x86"
835 vanilla_config="allmodconfig"
836 ubuntu_config="i386-config.flavour.generic"
837 ;;
838
839 "amd64")
840 karch="x86"
841 vanilla_config="allmodconfig"
842 ubuntu_config="amd64-config.flavour.generic"
843 ;;
844
845 "armhf")
846 karch="arm"
847 vanilla_config="allmodconfig"
848 ubuntu_config="armhf-config.flavour.generic"
849 ;;
850
851 "arm64")
852 karch="arm64"
853 vanilla_config="allmodconfig"
854 ubuntu_config="arm64-config.flavour.generic"
855 ;;
856
857 "powerpc")
858 karch="powerpc"
859 vanilla_config="allmodconfig"
860 ubuntu_config="powerpc-config.flavour.powerpc-smp"
861 ;;
862
863 "ppc64el")
864 karch="powerpc"
865 vanilla_config="allmodconfig"
866 ubuntu_config="ppc64el-config.flavour.generic"
867 ;;
868
869 *)
870 echo "Unsupported arch $arch"
871 exit 1
872 ;;
873 esac
874 else
875 echo "No arch or cross_arch specified"
876 exit 1
877 fi
878
879
880
881 # First get the kernel build from the object store, or build it, if it's
882 # not available.
883
884 echo "# Setup endpoint
885 host_base = obj.internal.efficios.com
886 host_bucket = obj.internal.efficios.com
887 bucket_location = us-east-1
888 use_https = True
889
890 # Setup access keys
891 access_key = jenkins
892 secret_key = echo123456
893
894 # Enable S3 v4 signature APIs
895 signature_v2 = False" > "$WORKSPACE/.s3cfg"
896
897 url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
898 obj_name="linux.tar.bz2"
899
900 if [ "x${cross_arch}" = "x" ]; then
901 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/$arch/native"
902 else
903 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/${cross_arch}"
904 fi
905
906 obj_url="$obj_url_prefix/$obj_name"
907
908 set +e
909 # In s3cmd 2.3, the return code of get when an object does not exist (64)
910 # is different than in 2.2 (12). The return codes of 's3cmd info' are
911 # consistent between 2.2 and 2.3.
912 s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
913 ret=$?
914 set -e
915
916 case "$ret" in
917 "0")
918 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
919 extract_archive_obj
920 ;;
921
922 "12")
923 echo "File not found"
924
925 # Build all the things and upload
926 # then finish the module build...
927
928 git_clone_linux_sources
929 git_export_linux_sources
930
931 select_compiler
932
933 ## PREPARE FULL LINUX SOURCE TREE
934 build_linux_kernel
935
936 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
937 extract_distro_headers
938
939 tar_archive_obj
940
941 upload_archive_obj
942
943 ;;
944
945 *)
946 echo "Unknown error? Abort"
947 exit 1
948 ;;
949 esac
950
951 select_compiler
952
953 selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
954 # lttng-modules requires gcc >= 5.1 for aarch64
955 # @see https://github.com/lttng/lttng-modules/commit/be06402dbdbea2f3394e60ec15c5d3356e2be416
956 if { verlt "${selected_cc_version}" "5.1"; } && [ "${cross_arch}" = "arm64" ] ; then
957 echo "Building lltng-modules on aarch64 requires gcc >= 5.1"
958 exit 0
959 fi
960
961 ## BUILD modules
962 # Either we downloaded a pre-build kernel or we built it and uploaded
963 # the archive for future builds.
964
965 cd "$WORKSPACE"
966
967 # Build modules against full kernel sources
968 build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
969
970 # Build modules against kernel headers
971 build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
972
973 # Make sure some modules were actually built
974 tree "${MODULES_OUTPUT_KSRC_DIR}"
975 if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
976 echo "No modules built!"
977 exit 1
978 fi
979
980 tree "${MODULES_OUTPUT_KHDR_DIR}"
981 if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
982 echo "No modules built!"
983 exit 1
984 fi
985
986 # EOF
This page took 0.06835 seconds and 5 git commands to generate.